#include "StdAfx.h"
#include "ScriptletDialog.h"
#include "WindowScriptletPlugin.h"

CScriptletDialog::CScriptletDialog(UINT nIDD):CBaseDialog(nIDD)
{
	m_pScriptletNode = NULL;
}

CScriptletDialog::~CScriptletDialog(void)
{
}
void CScriptletDialog::SetScriptletNode(TiXmlElement* pNode)
{
	m_pScriptletNode = pNode;
}
void CScriptletDialog::OnCreateContent(LPARAM lParam)
{
	LPCRECT rc = reinterpret_cast<LPCRECT>(lParam);
	if (rc)
	{
		this->SetWindowPos(NULL, rc->left, rc->top, 0, 0, SWP_NOSIZE | SWP_NOACTIVATE);
	}
}
IMPLEMENT_MESSAGE_HANDLER(CScriptletDialog, OnInitDlg)
{
	__super::OnInitDlg(uMsg, wParam, lParam, bHandled);
	
	if ( NULL != m_pScriptletNode )
	{
		CRootContainer* rootContainer = GetRootContainer();
		if (rootContainer != NULL)
		{
			rootContainer->SetDataContext(this->GetDataContext());
		}

		CWindowScriptletPlugin _WindowScript;
		_WindowScript.CreateBaseDialog(this, m_pScriptletNode);

		OnCreateContent(lParam);
		
		if (IsCenterWindow())
		{
			// [:2008-12-02] Ϳ atlwin CenterWindow   Լ ߰
			this->CenterWindow2();
		}
		this->UpdateWindow();
	}
	return 0;
}

BOOL CScriptletDialog::CenterWindow2(HWND hWndCenter) throw()
{
	ATLASSERT(::IsWindow(m_hWnd));

	// determine owner window to center against
	DWORD dwStyle = GetStyle();
	if(hWndCenter == NULL)
	{
		if(dwStyle & WS_CHILD)
			hWndCenter = ::GetParent(m_hWnd);
		else
			hWndCenter = ::GetWindow(m_hWnd, GW_OWNER);
	}

	// get coordinates of the window relative to its parent
	RECT rcDlg;
	::GetWindowRect(m_hWnd, &rcDlg);
	RECT rcArea;
	RECT rcCenter;
	HWND hWndParent;
	if(!(dwStyle & WS_CHILD))
	{
		// don't center against invisible or minimized windows
		if(hWndCenter != NULL)
		{
			DWORD dwStyleCenter = ::GetWindowLong(hWndCenter, GWL_STYLE);
			if(!(dwStyleCenter & WS_VISIBLE) || (dwStyleCenter & WS_MINIMIZE))
				hWndCenter = NULL;
		}

		// center within screen coordinates
		::SystemParametersInfo(SPI_GETWORKAREA, NULL, &rcArea, NULL);
		
		if(hWndCenter == NULL)
		{
			rcCenter = rcArea;
		}
		else
		{
			// [:2008-12-02] ȭ   
			RECT rcVirtualArea;
			rcVirtualArea.left = rcVirtualArea.top = 0;
			rcVirtualArea.right  = ::GetSystemMetrics( SM_CXVIRTUALSCREEN );
			rcVirtualArea.bottom  = ::GetSystemMetrics( SM_CYVIRTUALSCREEN );

			::GetWindowRect(hWndCenter, &rcCenter);
			if (!(rcArea.right-rcArea.left == rcCenter.right - rcCenter.left &&
				rcArea.bottom-rcArea.top == rcCenter.bottom - rcCenter.top))
				rcArea = rcVirtualArea;
		}

	}
	else
	{
		// center within parent client coordinates
		hWndParent = ::GetParent(m_hWnd);
		ATLASSERT(::IsWindow(hWndParent));

		::GetClientRect(hWndParent, &rcArea);
		ATLASSERT(::IsWindow(hWndCenter));
		::GetClientRect(hWndCenter, &rcCenter);
		::MapWindowPoints(hWndCenter, hWndParent, (POINT*)&rcCenter, 2);
	}

	int DlgWidth = rcDlg.right - rcDlg.left;
	int DlgHeight = rcDlg.bottom - rcDlg.top;

	// find dialog's upper left based on rcCenter
	int xLeft = (rcCenter.left + rcCenter.right) / 2 - DlgWidth / 2;
	int yTop = (rcCenter.top + rcCenter.bottom) / 2 - DlgHeight / 2;

	// if the dialog is outside the screen, move it inside
	if(xLeft < rcArea.left)
		xLeft = rcArea.left;
	else if(xLeft + DlgWidth > rcArea.right)
		xLeft = rcArea.right - DlgWidth;

	if(yTop < rcArea.top)
		yTop = rcArea.top;
	else if(yTop + DlgHeight > rcArea.bottom)
		yTop = rcArea.bottom - DlgHeight;

	// map screen coordinates to child coordinates
	return ::SetWindowPos(m_hWnd, NULL, xLeft, yTop, -1, -1,
		SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
}
